/*;  test_e.cc {\documentstyle{jsrc2latex}\font\tenrm=cmtt10} */

/*;  $$Revision: 1.1 $$ {\rhead{\sl test\_e.cc\quad\thepage}} */
/*;  $$Date: 2000/12/02 10:09:02 $$  */
/*;  $$Source: /home/shiiba/ohymos-lib/ohymos-current/test_e.cc,v $$  */

// @(#) test_e.cc Test simulation of class "Element"

#include <stdio.h>
#include <time.h> // time_t , tm 

#include "total.h" // 饹 Total_system 
#include "p_tmp.h"
  // ƥץ졼ȥ饹 Data, Receive, Send, I_file, O_file 

#include "elm_t.h" // 饹 Element_for_test 


// 饹 Test_of_element .

class Test_of_element : public Total_system {
  // Test_of_element 饹 Element ƥȤ뤿ηϥǥ

// 1.	ü, ü, ֥.

  // ü.
 protected:
  I_file<double> inp;
  void Register_input_ports(void)
  {
    Register((void*) &inp);
  }

  // ü.
 protected:
  O_file<double> outp;
  void Register_output_ports(void)
  {
    Register((void*) &outp);
  }

  // ֥.
 protected:
  Element_for_test elm_t;
  void Register_components(void)
  {
    Register((void*) &elm_t);
  }

  void Register_iterators(void) {}

  // ³.
 protected:
  void Connect_ports(void)
  {
    Connect(((void*) &inp), ((void*) &elm_t), "Receive", "rp", 0);
    Connect(((void*) &elm_t), "Send", "sp", 0, ((void*) &outp));
  }

  void Connect_components(void) {}

// ֤
 public:
  virtual void Set_initial_state(FILE* fp) {
    fscanf(fp, "%ld", &current_time);
    Sub_system::Initial_time(current_time);
    printf("\tIST\t: tst_e\t: current_time = %ld\n\n", current_time);
  }

//	2.	󥹥ȥ饯.
public:
  Test_of_element(char* inp_file, char* outp_file)
    :	Total_system(),
	inp(inp_file),
	outp(outp_file),
	elm_t("elm_t", 0)
  {
    class_name = "Test_of_element";

    Init("total_system", 0, 0);
    //  : object_name
    //  : object_number
    // 軰 : ȿ׻Ƿο
  }

};

void
cat_filename(	    // ե̾δʬȳĥҤι
  char* aBasepart,  // ե̾δʬ (. "foo")
  char* aExtension, // ե̾γĥʬ (. ".doc")
  char* aFilename   // ե̾Ǽ (. "foo.doc")
  //
  // ե̾ǼΰϡƤӽФץ
  // Ǥ餫ݤƤʤФʤޤ
  //
)
{
  aFilename[0] = '\0';
  strcpy(aFilename, aBasepart);
  strcat(aFilename, aExtension);
}

// ᥤץ

int main(void)
{

  char file_basepart[FILENAME_MAX];
  char inp_file[FILENAME_MAX];
  char outp_file[FILENAME_MAX];

  cout << "Input the basepart of the related files (ex. test_e): ";
  cin >> file_basepart;

  cat_filename(file_basepart, ".i0", inp_file);
  cat_filename(file_basepart, ".o0", outp_file);

  Test_of_element total_system(inp_file, outp_file); // ηϥǥ.

  // 鲼ѹɬפϤ̵֤Ǥ礦

  // total_system.Set_ohymos_option(); // simulation option 

  if (total_system.Construct() != YES)
  { printf("\n# Failure : Construct.\n"); return 1; }

  if (total_system.Switch() != YES)
  { printf("\n# Failure : Switch.\n"); return 1; }

  if (total_system.Are_you_ready() != YES)
  { printf("\n# Failure : Are_you_ready.\n"); return 1; }

  // ѥ᥿ե뤫ɤߤȤ
  char wfilename[FILENAME_MAX];
  cat_filename(file_basepart, ".pmt", wfilename);
  total_system.Read_parameter_file(wfilename);

  // ֤ե뤫ɤߤȤ
  cat_filename(file_basepart, ".ist", wfilename);
  total_system.Read_initial_state_file(wfilename);

  // üҥǡꥹȥ
  cat_filename(file_basepart, ".isd", wfilename);
  // If $(file_basepart).isd does not exist, nothig will be
  // done by the folloing function.
  total_system.Read_send_port_file(wfilename);

  total_system.Do_share_info();

  total_system.Initial_work();
  total_system.Work();

  // ǽ֤ե¸
  cat_filename(file_basepart, ".tst", wfilename);
  total_system.Write_terminal_state(wfilename);

  // üҤ˻ĤäƤǡե¸
  cat_filename(file_basepart, ".tsd", wfilename);
  total_system.Write_send_port_stock(wfilename);
  return 0;
}

/*; end of file */
