/*;  mempool.cc {\documentstyle[fleqn]{jsrc2latex}\font\tenrm=cmtt10} */

/*;  $$Revision: 1.1 $$ {\rhead{\sl mempool.cc\quad\thepage}} */
/*;  $$Date: 2000/12/02 10:06:23 $$  */
/*;  $$Source: /home/shiiba/ohymos-lib/ohymos-current/mempool.cc,v $$  */
/*;  $$RCShost: yodo.kuciv.kyoto-u.ac.jp $$  */

// @(#)

#include "mempool.h"

template < class T >
MemoryPool< T >::~MemoryPool()
{
  MemoryPool<T> *nextPtr = next;
  for (nextPtr = next; nextPtr != NULL; nextPtr = next) {
    next = next->next;
    delete [] ((char *)nextPtr);
  }
}

template < class T >
void MemoryPool < T >::expandTheFreeList(int howMany)
{
  //; next ݥ󥿤Τ˽ʬ礭Υ֥Ȥݤʤ
  //; Фʤʤ
  size_t size = (sizeof(T) > sizeof(MemoryPool<T> *)) ?
    sizeof(T) : sizeof(MemoryPool<T> *);
  MemoryPool<T> *runner = (MemoryPool<T> *)(new char[size]);

  next = runner;
  for (int i = 0; i < howMany; i++) {
    runner->next = (MemoryPool<T> *)(new char [size]);
    runner = runner->next;
  }
  runner->next = 0;
}

/*; Local Variables: *** */
/*; tab-width: 4 *** */
/*; fill-column: 72 *** */
/*; End: *** */

/*; end of file */
